package org.xdoclet.plugin.hibernate.qtags;

public class HibernateListTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.hibernate.qtags.HibernateListTag {
    public static final String NAME = "hibernate.list";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"lazy",
		"order-by",
		"inverse",
		"check",
		"subselect",
		"outer-join",
		"schema",
		"table",
		"where",
		"fetch",
		"node",
		"mutable",
		"batch-size",
		"access",
		"cascade",
		"catalog",
		"collection-type",
		"optimistic-lock",
		"embed-xml",
		"persister",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public HibernateListTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public HibernateListTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getLazy() {
		boolean required = false;
        String result = getNamedParameter("lazy");
        if(required && result == null) {
            bomb("lazy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("proxy")|| result.equals("no-proxy")|| result.equals("extra")) ) {
	                // todo we should say what file and line number too
	                bomb("lazy=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOrderBy() {
		boolean required = false;
        String result = getNamedParameter("order-by");
        if(required && result == null) {
            bomb("order-by=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getInverse() {
		boolean required = false;
        String result = getNamedParameter("inverse");
        if(required && result == null) {
            bomb("inverse=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getCheck() {
		boolean required = false;
        String result = getNamedParameter("check");
        if(required && result == null) {
            bomb("check=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSubselect() {
		boolean required = false;
        String result = getNamedParameter("subselect");
        if(required && result == null) {
            bomb("subselect=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOuterJoin() {
		boolean required = false;
        String result = getNamedParameter("outer-join");
        if(required && result == null) {
            bomb("outer-join=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("auto")) ) {
	                // todo we should say what file and line number too
	                bomb("outer-join=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSchema() {
		boolean required = false;
        String result = getNamedParameter("schema");
        if(required && result == null) {
            bomb("schema=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTable() {
		boolean required = false;
        String result = getNamedParameter("table");
        if(required && result == null) {
            bomb("table=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getWhere() {
		boolean required = false;
        String result = getNamedParameter("where");
        if(required && result == null) {
            bomb("where=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getFetch() {
		boolean required = false;
        String result = getNamedParameter("fetch");
        if(required && result == null) {
            bomb("fetch=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("join")|| result.equals("select")|| result.equals("subselect")) ) {
	                // todo we should say what file and line number too
	                bomb("fetch=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNode() {
		boolean required = false;
        String result = getNamedParameter("node");
        if(required && result == null) {
            bomb("node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getMutable() {
		boolean required = false;
        String result = getNamedParameter("mutable");
        if(required && result == null) {
            bomb("mutable=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getBatchSize() {
		boolean required = false;
        String result = getNamedParameter("batch-size");
        if(required && result == null) {
            bomb("batch-size=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAccess() {
		boolean required = false;
        String result = getNamedParameter("access");
        if(required && result == null) {
            bomb("access=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCascade() {
		boolean required = false;
        String result = getNamedParameter("cascade");
        if(required && result == null) {
            bomb("cascade=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCatalog() {
		boolean required = false;
        String result = getNamedParameter("catalog");
        if(required && result == null) {
            bomb("catalog=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCollectionType() {
		boolean required = false;
        String result = getNamedParameter("collection-type");
        if(required && result == null) {
            bomb("collection-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getOptimisticLock() {
		boolean required = false;
        String result = getNamedParameter("optimistic-lock");
        if(required && result == null) {
            bomb("optimistic-lock=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.Boolean getEmbedXml() {
		boolean required = false;
        String result = getNamedParameter("embed-xml");
        if(required && result == null) {
            bomb("embed-xml=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getPersister() {
		boolean required = false;
        String result = getNamedParameter("persister");
        if(required && result == null) {
            bomb("persister=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getLazy();
        getOrderBy();
        getInverse();
        getCheck();
        getSubselect();
        getOuterJoin();
        getSchema();
        getTable();
        getWhere();
        getFetch();
        getNode();
        getMutable();
        getBatchSize();
        getAccess();
        getCascade();
        getCatalog();
        getCollectionType();
        getOptimisticLock();
        getEmbedXml();
        getPersister();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}