package org.xdoclet.plugin.hibernate.qtags;

public class HibernateOneToOneTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.hibernate.qtags.HibernateOneToOneTag {
    public static final String NAME = "hibernate.one-to-one";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"constrained",
		"lazy",
		"formula",
		"outer-join",
		"class",
		"entity-name",
		"foreign-key",
		"fetch",
		"property-ref",
		"node",
		"cascade",
		"access",
		"embed-xml",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public HibernateOneToOneTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public HibernateOneToOneTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.Boolean getConstrained() {
		boolean required = false;
        String result = getNamedParameter("constrained");
        if(required && result == null) {
            bomb("constrained=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }
    public java.lang.String getLazy() {
		boolean required = false;
        String result = getNamedParameter("lazy");
        if(required && result == null) {
            bomb("lazy=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("proxy")|| result.equals("no-proxy")|| result.equals("extra")) ) {
	                // todo we should say what file and line number too
	                bomb("lazy=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getFormula() {
		boolean required = false;
        String result = getNamedParameter("formula");
        if(required && result == null) {
            bomb("formula=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getOuterJoin() {
		boolean required = false;
        String result = getNamedParameter("outer-join");
        if(required && result == null) {
            bomb("outer-join=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")|| result.equals("auto")) ) {
	                // todo we should say what file and line number too
	                bomb("outer-join=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getClass_() {
		boolean required = false;
        String result = getNamedParameter("class");
        if(required && result == null) {
            bomb("class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getEntityName() {
		boolean required = false;
        String result = getNamedParameter("entity-name");
        if(required && result == null) {
            bomb("entity-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getForeignKey() {
		boolean required = false;
        String result = getNamedParameter("foreign-key");
        if(required && result == null) {
            bomb("foreign-key=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getFetch() {
		boolean required = false;
        String result = getNamedParameter("fetch");
        if(required && result == null) {
            bomb("fetch=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("join")|| result.equals("select")|| result.equals("subselect")) ) {
	                // todo we should say what file and line number too
	                bomb("fetch=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPropertyRef() {
		boolean required = false;
        String result = getNamedParameter("property-ref");
        if(required && result == null) {
            bomb("property-ref=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNode() {
		boolean required = false;
        String result = getNamedParameter("node");
        if(required && result == null) {
            bomb("node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCascade() {
		boolean required = false;
        String result = getNamedParameter("cascade");
        if(required && result == null) {
            bomb("cascade=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAccess() {
		boolean required = false;
        String result = getNamedParameter("access");
        if(required && result == null) {
            bomb("access=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Boolean getEmbedXml() {
		boolean required = false;
        String result = getNamedParameter("embed-xml");
        if(required && result == null) {
            bomb("embed-xml=\"???\" must be specified.");
        }

		java.lang.Boolean retVal = null;


		if (result != null) {
		        retVal = Boolean.valueOf(result);
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getConstrained();
        getLazy();
        getFormula();
        getOuterJoin();
        getClass_();
        getEntityName();
        getForeignKey();
        getFetch();
        getPropertyRef();
        getNode();
        getCascade();
        getAccess();
        getEmbedXml();
    }

    public void validateModel() {
        // check uniqueness
    }
}