package org.xdoclet.plugin.hibernate.qtags;

public class HibernateTimestampTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.hibernate.qtags.HibernateTimestampTag {
    public static final String NAME = "hibernate.timestamp";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"unsaved-value",
		"source",
		"node",
		"access",
		"generated",
		"column",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public HibernateTimestampTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public HibernateTimestampTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getUnsavedValue() {
		boolean required = false;
        String result = getNamedParameter("unsaved-value");
        if(required && result == null) {
            bomb("unsaved-value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "null";
        }

		if (result != null) {
	            if( !(false || result.equals("null")|| result.equals("undefined")) ) {
	                // todo we should say what file and line number too
	                bomb("unsaved-value=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSource() {
		boolean required = false;
        String result = getNamedParameter("source");
        if(required && result == null) {
            bomb("source=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("vm")|| result.equals("db")) ) {
	                // todo we should say what file and line number too
	                bomb("source=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getNode() {
		boolean required = false;
        String result = getNamedParameter("node");
        if(required && result == null) {
            bomb("node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAccess() {
		boolean required = false;
        String result = getNamedParameter("access");
        if(required && result == null) {
            bomb("access=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getGenerated() {
		boolean required = false;
        String result = getNamedParameter("generated");
        if(required && result == null) {
            bomb("generated=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("newer")|| result.equals("always")|| result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("generated=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getColumn() {
		boolean required = false;
        String result = getNamedParameter("column");
        if(required && result == null) {
            bomb("column=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getUnsavedValue();
        getSource();
        getNode();
        getAccess();
        getGenerated();
        getColumn();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}